com.smartgwt.client.widgets.form.fields

## Class SpinnerItem

- java.lang.Object
- - com.smartgwt.client.core.JsObject
  - - com.smartgwt.client.core.DataClass
    - - com.smartgwt.client.core.RefDataClass
      - - com.smartgwt.client.widgets.form.fields.FormItem
        - - com.smartgwt.client.widgets.form.fields.TextItem
          - - com.smartgwt.client.widgets.form.fields.SpinnerItem

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers, HasBlurHandlers, HasChangedHandlers, HasChangeHandlers, HasClickHandlers, HasDoubleClickHandlers, HasEditorEnterHandlers, HasEditorExitHandlers, HasFocusHandlers, HasIconClickHandlers, HasIconKeyPressHandlers, HasItemHoverHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasKeyUpHandlers, HasPickerIconClickHandlers, HasTitleClickHandlers, HasTitleDoubleClickHandlers, HasTitleHoverHandlers, HasValueHoverHandlers

      public class SpinnerItem
      extends TextItem

  Item for picking a number. Includes arrow buttons to increase / decrease the value

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.RefDataClass

      `id`

    - ### Fields inherited from class com.smartgwt.client.core.JsObject

      `jsObj`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SpinnerItem()`
    `SpinnerItem(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `SpinnerItem(java.lang.String name)`
    `SpinnerItem(java.lang.String name, java.lang.String title)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `static void` | `changePickerIconDefaults(FormItemIcon defaults)`
    `java.lang.String` | `getMask()` Not applicable to a SpinnerItem.
    `java.lang.Boolean` | `getMaskOverwriteMode()` Not applicable to a SpinnerItem.
    `java.lang.String` | `getMaskPadChar()` Not applicable to a SpinnerItem.
    `java.lang.String` | `getMaskPromptChar()` Not applicable to a SpinnerItem.
    `java.lang.Boolean` | `getMaskSaveLiterals()` Not applicable to a SpinnerItem.
    `java.lang.Double` | `getMax()` Maximum valid value for this item
    `java.lang.Double` | `getMin()` Minimum valid value for this item
    `static SpinnerItem` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `double` | `getStep()` How much should the value be incremented / decremented when the user hits the icons to increase / decrease the value?
    `static void` | `setDefaultProperties(SpinnerItem spinnerItemProperties)` Class level method to set the default properties of this class.
    `void` | `setDefaultValue(java.lang.Double defaultValue)` Value used when no value is provided for this item.
    `void` | `setDefaultValue(java.lang.Integer defaultValue)` Value used when no value is provided for this item.
    `void` | `setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `void` | `setMask(java.lang.String mask)` Not applicable to a SpinnerItem.
    `void` | `setMaskOverwriteMode(java.lang.Boolean maskOverwriteMode)` Not applicable to a SpinnerItem.
    `void` | `setMaskPadChar(java.lang.String maskPadChar)` Not applicable to a SpinnerItem.
    `void` | `setMaskPromptChar(java.lang.String maskPromptChar)` Not applicable to a SpinnerItem.
    `void` | `setMaskSaveLiterals(java.lang.Boolean maskSaveLiterals)` Not applicable to a SpinnerItem.
    `void` | `setMax(java.lang.Double max)` Maximum valid value for this item
    `void` | `setMax(java.lang.Integer max)`
    `void` | `setMin(java.lang.Double min)` Minimum valid value for this item
    `void` | `setMin(java.lang.Integer min)`
    `void` | `setStep(double step)` How much should the value be incremented / decremented when the user hits the icons to increase / decrease the value?
    `void` | `setStep(int step)`

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.TextItem

      `deselectValue, deselectValue, getBrowserAutoCapitalize, getBrowserAutoCorrect, getBrowserInputType, getChangeOnKeypress, getCharacterCasing, getEnteredValue, getFormatOnBlur, getFormatOnFocusChange, getHeight, getHint, getKeyPressFilter, getLength, getPrintFullText, getSaveOnEnter, getSelectionRange, getSelectOnClick, getSelectOnFocus, getShowHintInField, getTextBoxStyle, getValueAsString, getWidth, selectValue, setBrowserAutoCapitalize, setBrowserAutoCorrect, setBrowserInputType, setChangeOnKeypress, setCharacterCasing, setDefaultProperties, setFormatOnBlur, setFormatOnFocusChange, setHeight, setKeyPressFilter, setLength, setPrintFullText, setSaveOnEnter, setSelectionRange, setSelectOnClick, setSelectOnFocus, setShowHintInField, setTextBoxStyle, setWidth`

    - ### Methods inherited from class com.smartgwt.client.widgets.form.fields.FormItem

      `_getValue, addBlurHandler, addChangedHandler, addChangeHandler, addClickHandler, addDoubleClickHandler, addEditorEnterHandler, addEditorExitHandler, addFocusHandler, addIconClickHandler, addIconKeyPressHandler, addItemHoverHandler, addKeyDownHandler, addKeyPressHandler, addKeyUpHandler, addPickerIconClickHandler, addTitleClickHandler, addTitleDoubleClickHandler, addTitleHoverHandler, addValueHoverHandler, asSGWTComponent, blurItem, canEditCriterion, clearValue, disable, enable, focusInItem, getAccessKey, getAlign, getAllowExpressions, getAlwaysFetchMissingValues, getApplyHeightToTextBox, getAriaRole, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsString, getBrowserSpellCheck, getCanEdit, getCanFocus, getCanvasAutoChild, getCellHeight, getCellStyle, getClassName, getClipStaticValue, getClipTitle, getConfig, getContainerWidget, getCriteriaField, getCriterion, getCriterion, getDataPath, getDateFormatter, getDecimalPad, getDecimalPrecision, getDefaultIconSrc, getDisabled, getDisableIconsOnReadOnly, getDisplayField, getDisplayFieldName, getDisplayValue, getDisplayValue, getEditorTypeConfig, getEditPendingCSSText, getEmptyDisplayValue, getEmptyValueIcon, getEndRow, getErrorIconHeight, getErrorIconSrc, getErrorIconWidth, getErrorMessageWidth, getFetchMissingValues, getFieldName, getFilterLocally, getForm, getFormItemAutoChild, getFullDataPath, getGlobalTabIndex, getHintStyle, getHoverAlign, getHoverDelay, getHoverHeight, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getIcon, getIconHeight, getIconHSpace, getIconPageRect, getIconPrompt, getIconRect, getIconVAlign, getIconWidth, getImageURLPrefix, getImageURLSuffix, getImplicitSave, getImplicitSaveOnBlur, getInputFormat, getLeft, getLocateItemBy, getMultipleValueSeparator, getName, getOperator, getOptionCriteria, getOptionFilterContext, getOptionOperationId, getPageLeft, getPageRect, getPageTop, getPicker, getPickerIconHeight, getPickerIconName, getPickerIconPrompt, getPickerIconProperties, getPickerIconSrc, getPickerIconStyle, getPickerIconWidth, getPrintTextBoxStyle, getPrintTitleStyle, getPrompt, getReadOnlyDisplay, getReadOnlyTextBoxStyle, getRect, getRedrawOnChange, getRejectInvalidValueOnChange, getRequired, getRequiredMessage, getRowSpan, getSelectedRecord, getShouldSaveValue, getShowClippedTitleOnHover, getShowClippedValueOnHover, getShowDisabled, getShowErrorIcon, getShowErrorStyle, getShowErrorText, getShowFocused, getShowFocusedErrorState, getShowFocusedIcons, getShowFocusedPickerIcon, getShowHint, getShowIcons, getShowOverIcons, getShowPickerIcon, getShowRTL, getShowTitle, getShowValueIconOnly, getStartRow, getStopOnError, getSuppressValueIcon, getSynchronousValidation, getTabIndex, getTextAlign, getTimeFormatter, getTitle, getTitleAlign, getTitleColSpan, getTitleOrientation, getTitleStyle, getTitleVAlign, getTooltip, getTop, getType, getValidateOnChange, getValidateOnExit, getValidOperators, getVAlign, getValue, getValueAsRecordList, getValueField, getValueFieldName, getValueIconHeight, getValueIconLeftPadding, getValueIconRightPadding, getValueIconSize, getValueIconWidth, getVisible, getVisibleHeight, getVisibleWidth, getWrapTitle, hasAdvancedCriteria, hide, hideIcon, invalidateDisplayValueCache, isCreated, isDisabled, isDrawn, isVisible, redraw, setAccessKey, setAlign, setAllowExpressions, setAlwaysFetchMissingValues, setApplyHeightToTextBox, setAriaRole, setAriaState, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setBrowserSpellCheck, setCanEdit, setCanEditCriterionPredicate, setCanFocus, setCellHeight, setCellStyle, setClipStaticValue, setClipTitle, setColSpan, setColSpan, setCriteriaField, setCriterion, setCriterionGetter, setCriterionSetter, setDataPath, setDateFormatter, setDecimalPad, setDecimalPrecision, setDefaultIconSrc, setDefaultProperties, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDefaultValue, setDisabled, setDisableIconsOnReadOnly, setDisplayField, setDisplayFormat, setDisplayFormat, setEditorProperties, setEditorType, setEditorType, setEditorType, setEditorValueFormatter, setEditorValueParser, setEditPendingCSSText, setEmptyDisplayValue, setEmptyValueIcon, setEndRow, setErrorFormatter, setErrorIconHeight, setErrorIconSrc, setErrorIconWidth, setErrorMessageWidth, setErrorOrientation, setFetchMissingValues, setFilterLocally, setGlobalTabIndex, setHeight, setHint, setHintStyle, setHoverAlign, setHoverDelay, setHoverHeight, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setIconHeight, setIconHSpace, setIconPrompt, setIcons, setIconVAlign, setIconWidth, setImageURLPrefix, setImageURLSuffix, setImplicitSave, setImplicitSaveOnBlur, setInitHandler, setInputFormat, setInputTransformer, setItemHoverFormatter, setItemTitleHoverFormatter, setItemValueHoverFormatter, setLeft, setLocateItemBy, setMultipleValueSeparator, setName, setOperator, setOptionCriteria, setOptionDataSource, setOptionFilterContext, setOptionOperationId, setPickerIconHeight, setPickerIconName, setPickerIconPrompt, setPickerIconProperties, setPickerIconSrc, setPickerIconStyle, setPickerIconWidth, setPrintTextBoxStyle, setPrintTitleStyle, setPrompt, setProperty, setProperty, setProperty, setProperty, setProperty, setReadOnlyDisplay, setReadOnlyTextBoxStyle, setRedrawOnChange, setRejectInvalidValueOnChange, setRequired, setRequiredMessage, setRowSpan, setShouldSaveValue, setShowClippedTitleOnHover, setShowClippedValueOnHover, setShowDisabled, setShowErrorIcon, setShowErrorStyle, setShowErrorText, setShowFocused, setShowFocusedErrorState, setShowFocusedIcons, setShowFocusedPickerIcon, setShowHint, setShowIcons, setShowIfCondition, setShowOverIcons, setShowPickerIcon, setShowRTL, setShowTitle, setShowValueIconOnly, setStartRow, setStopOnError, setSuppressValueIcon, setSynchronousValidation, setTabIndex, setTextAlign, setTimeFormatter, setTitle, setTitleAlign, setTitleColSpan, setTitleHoverFormatter, setTitleOrientation, setTitleStyle, setTitleVAlign, setTooltip, setTop, setType, setValidateOnChange, setValidateOnExit, setValidators, setValidOperators, setVAlign, setValue, setValue, setValue, setValue, setValue, setValue, setValueField, setValueFormatter, setValueHoverFormatter, setValueIconHeight, setValueIconLeftPadding, setValueIconMapper, setValueIconRightPadding, setValueIcons, setValueIconSize, setValueIconWidth, setValueMap, setValueMap, setVisible, setWidth, setWrapTitle, shouldApplyHeightToTextBox, shouldFetchMissingValue, shouldSaveOnEnter, show, showIcon, showPicker, stopHover, updateState, validate, valueClipped`

    - ### Methods inherited from class com.smartgwt.client.core.RefDataClass

      `getRef, getRef, internalSetID`

    - ### Methods inherited from class com.smartgwt.client.core.DataClass

      `doAddHandler, fireEvent, getAttributeAsDoubleArray, getAttributeAsIntArray, getAttributeAsLong, getAttributeAsMap, getAttributeAsObject, getAttributeAsRecord, getAttributeAsStringArray, getAttributes, getHandlerCount, getJsObj, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttributeAsJavaObject`

    - ### Methods inherited from class com.smartgwt.client.core.JsObject

      `equals, hashCode, setJsObj`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### SpinnerItem

          public SpinnerItem()

    - #### SpinnerItem

          public SpinnerItem(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### SpinnerItem

          public SpinnerItem(java.lang.String name)

    - #### SpinnerItem

          public SpinnerItem(java.lang.String name,
                     java.lang.String title)

  - ### Method Detail

    - #### getOrCreateRef

          public static SpinnerItem getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### setJavaScriptObject

          public void setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)

      Overrides:
        `setJavaScriptObject` in class `TextItem`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties.
      See Also:
        `AutoChildUsage`

    - #### changePickerIconDefaults

          public static void changePickerIconDefaults(FormItemIcon defaults)

    - #### setMask

          public void setMask(java.lang.String mask)

      Not applicable to a SpinnerItem.

      Note : This is an advanced setting

      Overrides:
        `setMask` in class `TextItem`
      Parameters:
        `mask` - . See `String`. Default value is null
      See Also:
        `TextItem.setKeyPressFilter(java.lang.String)`, Text - Masked Example

    - #### getMask

          public java.lang.String getMask()

      Not applicable to a SpinnerItem.
      Overrides:
        `getMask` in class `TextItem`
      Returns:
        . See `String`
      See Also:
        `TextItem.getKeyPressFilter()`, Text - Masked Example

    - #### setMaskOverwriteMode

          public void setMaskOverwriteMode(java.lang.Boolean maskOverwriteMode)

      Not applicable to a SpinnerItem.

      Note : This is an advanced setting

      Overrides:
        `setMaskOverwriteMode` in class `TextItem`
      Parameters:
        `maskOverwriteMode` - maskOverwriteMode Default value is null

    - #### getMaskOverwriteMode

          public java.lang.Boolean getMaskOverwriteMode()

      Not applicable to a SpinnerItem.
      Overrides:
        `getMaskOverwriteMode` in class `TextItem`
      Returns:
        Boolean

    - #### setMaskPadChar

          public void setMaskPadChar(java.lang.String maskPadChar)

      Not applicable to a SpinnerItem.

      Note : This is an advanced setting

      Overrides:
        `setMaskPadChar` in class `TextItem`
      Parameters:
        `maskPadChar` - . See `String`. Default value is " "

    - #### getMaskPadChar

          public java.lang.String getMaskPadChar()

      Not applicable to a SpinnerItem.
      Overrides:
        `getMaskPadChar` in class `TextItem`
      Returns:
        . See `String`

    - #### setMaskPromptChar

          public void setMaskPromptChar(java.lang.String maskPromptChar)

      Not applicable to a SpinnerItem.

      Note : This is an advanced setting

      Overrides:
        `setMaskPromptChar` in class `TextItem`
      Parameters:
        `maskPromptChar` - . See `String`. Default value is "_"

    - #### getMaskPromptChar

          public java.lang.String getMaskPromptChar()

      Not applicable to a SpinnerItem.
      Overrides:
        `getMaskPromptChar` in class `TextItem`
      Returns:
        . See `String`

    - #### setMaskSaveLiterals

          public void setMaskSaveLiterals(java.lang.Boolean maskSaveLiterals)

      Not applicable to a SpinnerItem.

      Note : This is an advanced setting

      Overrides:
        `setMaskSaveLiterals` in class `TextItem`
      Parameters:
        `maskSaveLiterals` - maskSaveLiterals Default value is null

    - #### getMaskSaveLiterals

          public java.lang.Boolean getMaskSaveLiterals()

      Not applicable to a SpinnerItem.
      Overrides:
        `getMaskSaveLiterals` in class `TextItem`
      Returns:
        Boolean

    - #### setDefaultProperties

          public static void setDefaultProperties(SpinnerItem spinnerItemProperties)

      Class level method to set the default properties of this class. If set, then all subsequent instances of this class will automatically have the default properties that were set when this method was called. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will effect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead.

      Parameters:
        `spinnerItemProperties` - properties that should be used as new defaults when instances of this class are created

    - #### setStep

          public void setStep(double step)

      How much should the value be incremented / decremented when the user hits the icons to increase / decrease the value?
      Parameters:
        `step` - step Default value is 1

    - #### setStep

          public void setStep(int step)

    - #### getStep

          public double getStep()

      How much should the value be incremented / decremented when the user hits the icons to increase / decrease the value?
      Returns:
        int

    - #### setMax

          public void setMax(java.lang.Double max)

      Maximum valid value for this item
      Parameters:
        `max` - max Default value is null

    - #### setMax

          public void setMax(java.lang.Integer max)

    - #### getMax

          public java.lang.Double getMax()

      Maximum valid value for this item
      Returns:
        Integer

    - #### setMin

          public void setMin(java.lang.Double min)

      Minimum valid value for this item
      Parameters:
        `min` - min Default value is null

    - #### setMin

          public void setMin(java.lang.Integer min)

    - #### getMin

          public java.lang.Double getMin()

      Minimum valid value for this item
      Returns:
        Integer

    - #### setDefaultValue

          public void setDefaultValue(java.lang.Double defaultValue)

      Description copied from class: `FormItem`
      Value used when no value is provided for this item. Note that whenever this item's value is cleared by the user or set to `null` programatically, it will be reverted to the `defaultValue`. Developers should use the `values` object if their intention is to provide an initial value for a field in a form rather than a value to use in place of `null`.
      Overrides:
        `setDefaultValue` in class `FormItem`
      Parameters:
        `defaultValue` - defaultValue Default value is null

    - #### setDefaultValue

          public void setDefaultValue(java.lang.Integer defaultValue)

      Description copied from class: `FormItem`
      Value used when no value is provided for this item. Note that whenever this item's value is cleared by the user or set to `null` programatically, it will be reverted to the `defaultValue`. Developers should use the `values` object if their intention is to provide an initial value for a field in a form rather than a value to use in place of `null`.
      Overrides:
        `setDefaultValue` in class `FormItem`
      Parameters:
        `defaultValue` - defaultValue Default value is null